var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from "@angular/core";
import { FormBuilder, FormControl, Validators } from "@angular/forms";
var HTML_COMPONENT = "\n<div>\n<form [formGroup]=\"validations_form\" class=\"\">\n<div [ngStyle]=\"this.customStyle.divInputText\">\n  <ion-icon [ngStyle]=\"this.customStyle.userIcon\" name=\"md-person\"></ion-icon>\n  <ion-input\n    type=\"text\"\n    formControlName=\"username\"\n    [ngStyle]=\"this.customStyle.formControl\"\n    required\n  ></ion-input>\n</div>\n<div [ngStyle]=\"this.customStyle.validationErrors\">\n  <ng-container *ngFor=\"let validation of validation_messages.username\">\n    <div\n    [ngStyle]=\"this.customStyle.errorMessage\"\n      *ngIf=\"\n        validations_form.get('username').hasError(validation.type) &&\n        (validations_form.get('username').dirty ||\n          validations_form.get('username').touched)\n      \"\n    >\n      {{ validation.message }}\n    </div>\n  </ng-container>\n</div>\n</form>\n</div>\n";
var FormUsername = /** @class */ (function () {
    function FormUsername(formBuilder) {
        this.formBuilder = formBuilder;
        this.customStyle = {
            divInputText: JSON.parse("{ \"display\": \"flex\" ,\n    \"align-items\": \"center\",\n    \"margin-top\": \"5px\",\n    \"padding\": \"0\",\n    \"background\": \"var(--ion-color-primary)\",\n    \"border-radius\": \"0.5em\"}"),
            userIcon: JSON.parse("{\n      \"color\": \"var(--ion-color-primary-contrast)\",\n      \"float\": \"left\",\n      \"font-size\": \"20px\",\n      \"margin-left\": \"3px\"\n      }"),
            formControl: JSON.parse("{\n      \"color\": \"var(--ion-color-primary-contrast)\"\n      }"),
            validationErrors: JSON.parse("{\"display\": \"flex\",\n    \"flex-direction\":\"column\",\n  \"justify-content\": \"center\",\n  \"align-items\": \"center\"\n  }"),
            errorMessage: JSON.parse("{\"font-size\": \"0.9em\",\n      \"margin-top\": \"3px\",\n      \"color\": \"var(--ion-color-danger)\"\n      }")
        };
        this.validation_messages = {
            username: [
                { type: "required", message: "Username is required." },
                {
                    type: "minlength",
                    message: "Username must be at least 5 characters long."
                },
                {
                    type: "maxlength",
                    message: "Username cannot be more than 25 characters long."
                },
                {
                    type: "pattern",
                    message: "Your username must contain only numbers and letters."
                },
                {
                    type: "validUsername",
                    message: "Your username has already been taken."
                }
            ]
        };
    }
    FormUsername.prototype.ngOnInit = function () {
        this.validations_form = this.formBuilder.group({
            username: new FormControl("", Validators.compose([
                Validators.maxLength(25),
                Validators.minLength(5),
                Validators.pattern("^(?=.*[a-zA-Z])(?=.*[0-9])[a-zA-Z0-9]+$"),
                Validators.required
            ]))
        });
    };
    FormUsername = __decorate([
        Component({
            selector: "form-username",
            template: HTML_COMPONENT
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], FormUsername);
    return FormUsername;
}());
export { FormUsername };
//# sourceMappingURL=form-username-component.js.map